package fr.lbenoit.article.jdk14.test.switchexpressions;

/*-
 * #%L
 * jdk16-nouveautes
 * %%
 * Copyright (C) 2021 Lilian BENOIT
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */


import org.junit.Assert;
import org.junit.Test;

import fr.lbenoit.article.jdk14.switchexpressions.Jour;

public class JourTest {
	
	@Test
	public void TestCalculNbLettresJours() {
		Assert.assertEquals(5, calculeNbLettre(Jour.LUNDI));
		Assert.assertEquals(5, calculeNbLettre(Jour.MARDI));
		Assert.assertEquals(8, calculeNbLettre(Jour.MERCREDI));
		Assert.assertEquals(5, calculeNbLettre(Jour.JEUDI));
		Assert.assertEquals(8, calculeNbLettre(Jour.VENDREDI));
		Assert.assertEquals(6, calculeNbLettre(Jour.SAMEDI));
		Assert.assertEquals(8, calculeNbLettre(Jour.DIMANCHE));
	};
	
	protected int calculeNbLettre(Jour j) {
		int nbLettres = switch (j) {
	    case LUNDI, MARDI, JEUDI 			-> 5;
	    case SAMEDI							-> 6;
	    case MERCREDI, VENDREDI, DIMANCHE	-> 8;
		};
		return nbLettres;
	}
}
